/*
Copyright 1998-2005 Erik Aronesty. All rights reserved.

        1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

        2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

	3. Original source code, information and documentation is available at www.smxlang.org

THIS SOFTWARE IS PROVIDED 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE SMX AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

#include "stdafx.h"
#include "qctx.h"

#ifdef unix
#define NO_LOAD_SCHED
#endif
#define NO_LOAD_TSET
#include "libs.h"

#include "qenvbuf.h"

int main()
{
        qEnvBuf buf;

        qCtxTmp ctx(&buf);

        LoadAllLibs(&ctx);

	// load and parse
	ctx.Parse("%module(.libs/libextperl.so)%perl(output(2*2))", &buf);
	printf("2*2 is: %s\n", (const char *) buf.GetS());

	ctx.Parse("%perl($x=2*4; export('$x'))%x%", &buf);
	printf("2*4 is: %s\n", (const char *) buf.GetS());

	ctx.Parse("%perl(use Cwd; export('getcwd')) %getcwd()", &buf);

	printf("cwd is: %s\n", (const char *) buf.GetS());

	return 0;
}
