%define name smx
%define ver 1.1.4
%define rel 454

Summary: 	Server Macro eXpansion Language
Name: 		%{name}
Version: 	%{ver}
Release: 	%{rel}
Source: 	%{name}-%{ver}.tar.gz
Vendor: 	Erik Aronesty <erik@smxlang.org>
URL: 		http://www.smxlang.org/
License: 	BSD
Group: 		Development/Languages
Prefix: 	%{_prefix}
BuildRoot: 	%{_tmppath}/%{name}-%{ver}-root

BuildRequires: gcc-c++
BuildRequires: glibc-devel

# actually it doesn't require more than the above
# configure will just build a version without these features
# but relying on that for packaging seems to be 
# not what people want

BuildRequires: unixODBC-devel >= 2.0
BuildRequires: openssl-devel >= 0.9

%if %{?suse_version:1}0
BuildRequires: apache2-devel
%endif

%if %{?mandriva_version:1}0
BuildRequires: apache-devel >= 2.0
%endif

%if %{?fedora_version}%{?fedora}0
BuildRequires: perl-ExtUtils-Embed
%endif

%if %{?fedora_version}%{?rhel_version}%{?centos_version}%{?fedora}%{?rhel}0
BuildRequires: httpd-devel
%endif

%description
SMX is a simple macro language that can be used to parse text files
and replace inline macros. Contains the smx command-line and cgi 
tool, as well as the modsmx apache module, and extperl plugin.

%package devel
Summary: Libraries, includes to develop applications with %{name}
Group: Development/Libraries
Requires: %{name} = %{ver}

%description devel
The %{name}-devel package contains the header files and static libraries for
building applications which use %{name}.

%prep
%setup -q

%build

%configure

%install

make DESTDIR=%{buildroot} install

# without these lines, i get "unstripped binary" in rpmlint
strip --strip-unneeded %{buildroot}/%{_libdir}/*.so
strip --strip-unneeded %{buildroot}/%{_bindir}/smx*

rm -f %{buildroot}/%{_libdir}/*.la
rm -f %{buildroot}/%{_libdir}/*.a

%clean
rm -rf %{buildroot}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc AUTHORS ChangeLog COPYING INSTALL README TODO
%{_bindir}/smx*
%{_libdir}/libsmx.*
%{_libdir}/libmodsmx.*
%{_libdir}/libextperl.*
%{_prefix}/share/man/man3/%%*

%files devel
%defattr(-,root,root)
%{_includedir}/smxext.h

%changelog
* Tue Mar 17 2010 EA 1.1.4-442 
- Delinting spec (unstripped binary, manpage %%)
* Tue Mar 17 2009 EA 1.1.4-437 
- Getting spec to work on SUSE
* Sun Mar 26 2006 EA 
- Made spec.in autoconf'ed
* Mon Feb 27 2006 EA 
- First draft of the spec file

